<?PHP
// install - Installation des Plugins-spip

// Section de d&eacute;finition du Plug-in

	$plugin_titre = 'Raccourcis';
	
	$plugin_version = "1.0";

	// Repertoire ou sont les fichiers d'installation du plug-in

	
	// Repertoire Racine,  modifier SPIP n'est pas install dans le rep principal (doit finir par /)
	$root_dir = './';

	$install_dir = $root_dir."raccourcis/";
	
	// Repertoire o&ugrave; sont plac&eacute;es les sources du plugin (au sein du rep d'installation)
	$sources_dir = 'sources/';
	// Repertoire de sauvegarde des fichiers modifi&eacute;s
	$backup_dir = 'bak/';

// extension des fichiers par d&eacute;faut
if (!isset($extension))
{ $extension = 'php3'; };

chdir('..');
include "ecrire/inc_version.$extension";

if (!isset($etape)) {
	$etape = 1;
}

// Etape 6 (Transparente) Verouillage et redirection vers le plugin
if ($etape == 6) {
	$url = "../ecrire/raccourcis.$extension?auto_install=1";
	
	if ($verouiller_install)
	{	$verrou = "deny from all";
		// Verouille le fichier de sauvegarde
		$file = fopen($install_dir.$backup_dir.".htaccess","w");
		fwrite($file,$verrou,strlen($verrou));
		fclose($file);
		// Verouile le fichier d'installation
		$file = fopen($install_dir.".htaccess","w");
		fwrite($file,$verrou,strlen($verrou));
		fclose($file);
	}
	header("Location:$url");
}

$titre = "Installation $plugin_titre - Etape $etape";

// Section de D&eacute;claration des fichiers de SPIP &agrave; copier/modifier

// type de copie
//	0 : remplacer
//	1 : recherche et remplacement d'une chaine
//  2 : fichier nouveau &agrave; installer (remplacement, pas de sauvegarde)

function declare_fichier($nom,$chemin,$modif,$copie) {
	global $fichiers;
	$fichiers['nom'][] = $nom;
	$fichiers['chemin'][] = $chemin;
	$fichiers['verifier_modif'][] = $modif;
	$fichiers['copie'][] = $copie;

}

// D&eacute;finie les recherches et remplacement &agrave; faire dans un fichier
function recherche_fichier($nom,$recherche,$remplacer_par) {
	global $recherche_fichier;
	$recherche_fichier['recherche'][$nom] = $recherche;
	$recherche_fichier['remplacer'][$nom] = $remplacer_par;
}

// fichier &agrave; remplacer (ou modifier manuellement)

declare_fichier('inc-calcul','',true,0);
declare_fichier('inc_logos','ecrire/',true,0);

// articles
declare_fichier('articles','ecrire/',true,1);
recherche_fichier("articles","_T\('logo_survol'\)\)","_T('logo_survol'),\$titre)");

// Breves
declare_fichier('breves_voir','ecrire/',true,1);
recherche_fichier('breves_voir',"_T\('logo_survol'\)\)","_T('logo_survol'),\$titre_breve)");

// sites
declare_fichier('sites','ecrire/',true,1);
recherche_fichier('sites',"_T\('logo_survol'\)\)","_T('logo_survol'),\$nom_site)");

// mots
declare_fichier('mots_edit','ecrire/',true,1);
recherche_fichier('mots_edit',"_T\('logo_survol'\)\)","_T('logo_survol'),\$titre_mot)");


// fichier &agrave; installer
declare_fichier('raccourcis','ecrire/',false,2);
declare_fichier('inc_raccourcis','ecrire/',false,2);
declare_fichier('raccourcis-24.gif','ecrire/img_pack',false,2);
declare_fichier('directory-24.png','ecrire/img_pack',false,2);

// Fin de d&eacute;claration des fichiers

// Debut de HTML (install_debut_html legerement modifi&eacute;e)
?>
<html>
<head>
<title><?php echo $titre; ?></title>
<meta http-equiv="Expires" content="0">
<meta http-equiv="cache-control" content="no-cache,no-store">
<meta http-equiv="pragma" content="no-cache">
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">

<style>
<!--
	a {text-decoration: none; }
	A:Hover {color:#FF9900; text-decoration: underline;}
	.forml {width: 100%; background-color: #FFCC66; background-position: center bottom; float: none; color: #000000}
	.formo {width: 100%; background-color: #FFF0E0; background-position: center bottom; weight: bold; float: none; color: #000000}
	.fondl {background-color: #FFCC66; background-position: center bottom; float: none; color: #000000}
	.fondo {background-color: #FFF0E0; background-position: center bottom; float: none; color: #000000}
	.fondf {background-color: #FFFFFF; border-style: solid ; border-width: 1; border-color: #E86519; color: #E86519}
-->
</style>
</head>

<body bgcolor="#FFFFFF" text="#000000" link="#E86519" vlink="#6E003A" alink="#FF9900" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">
<br>
<center>
<table width="600">
<tr><td width="600">
<font face="Verdana,Arial,Helvetica,sans-serif" size="5" color="#970038"><B><?php 
	echo $titre; 
?></b></font>
<font face="Georgia,Garamond,Times,serif" size="3">

<?php

// Formulaire du bouton suivant
function form_suivant() {
	global $install_dir,$form_suivant,$extension;
	echo "<form action='install.$extension' method='post'>";
	$form_suivant = true;
}

// creation du bouton suivant et passage des param&egrave;tres 
function bouton_suivant($num_etape,$params ='') {
	global $extension,$etape,$form_suivant;
	if (!$form_suivant) {
		form_suivant();
	}
	echo "<div align='right'><form action='install.php' method='post'>";
	echo "<INPUT TYPE='hidden' name='etape' value='$num_etape'>";
	if ($etape > 1) {
		echo "<INPUT TYPE='hidden' name='extension' value='$extension'>";
	}
	echo "<INPUT TYPE='submit' name='submit' value='Suivant' class='fondo'>";
	// au cas ou, je ne l'utilise pas ici...
	if ($params) {
		while( list($name,$value) = each($params)) {
			echo "<INPUT TYPE='hidden' name='$name' value='$value'>";
		}
	}
	echo "</div></form>";
}

// Si possible, permissiob max pour les fichiers copiés/crées

// Premiere etape : Pr&eacute;sentation, type de fichier
if ($etape == 1) {
	echo "<h2>Pr&eacute;sentation</h2>";
	echo "<p>Ce plug-in SPIP permet une gestion alternative des images SPIP en permettant un stockage des images dans des sous-repertoire d'IMG. Le nom de fichiers des images n'est pas modifi&eacute;. le fichier  de SPIP (type artonXXX), qui porte l'extension &quot;.url&quot; contient le chemin vers l'image<p>";
	
	echo "<p align='center'>SPIP version $spip_version_affichee : ";

	if ($spip_version_affichee == "1-6") {
		echo " Version compatible</p>";
	}
	else {
		 echo "<br>Cette version ne peut pas b&eacute;n&eacute;ficier de l'installation automatique";
	     echo "Vous devrez faire les changement de script manuellement.";
	}
	form_suivant();
	echo "Mes extensions de SPIP sont en .php3 <input type='checkbox' name='extension' value='php3'>.<br>";
	echo "Attention ! L'install que vous lancez doit porter la même extension que vos fichiers SPIP";
	bouton_suivant($etape + 1);
}

// Etape 2 : Sauvegarde des fichiers qui seront modifi&eacute;s
// le .org est rajout&eacute; (evite de prendre ca pour un .bak &agrave; supprimer

if ($etape == 2) {
		echo "<p><b>Sauvegarde des fichiers &agrave; modifier</b></p>";
	
	if (!file_exists($install_dir.$bak_dir)) {
		mkdir($install_dir.$bak_dir,0777);
	}
	
	while( list($key,$value) = each($fichiers['nom'])) {
		if ($fichiers['copie'][$key] < 2) {
		$chemin = $fichiers['chemin'][$key];
		$source = $chemin.$value.".".$extension;
		$dest = $install_dir.$backup_dir.$value.".".$extension.".org";		
		copy($source,$dest);
		echo "Sauvegarde de $chemin$value.$extension dans $install_dir (.org)<br>";
		}
	}
bouton_suivant($etape + 1);
} 

// Etape 3 - Fichiers qui vont être modifiés, possibilité d'ignorer ou mode simultanné;

if ($etape == 3) {

echo "<p><b>Avez-vous modifi&eacute; un de ces fichiers ?</b></p>";
form_suivant();

	while( list($key,$value) = each($fichiers['nom'])) {
			$mark = '';
			if ($fichiers['copie'][$key] == 1) {
				$mark = '[*]';
			}
			$chemin = $fichiers['chemin'][$key];
			if ($fichiers['verifier_modif'][$key]) {			
			echo "<INPUT TYPE='checkbox' NAME='modifie[$key]' value='$value'>$chemin$value.$extension $mark<br>";
			}
	}
echo "<p><INPUT TYPE='checkbox' NAME='mode_simule' value='1'> Mode Simul&eacute; (ne fera rien sur aucun fichier).</p>";
echo "<p>Si vous ne souhaitez pas que l'installation remplace ou modifie vos fichiers directement, ne continuez pas l'installation, proc&eacute;dez en mode simul&eacute;</p>";
echo "<p>Les fichiers notifi&eacute;s comme modifi&eacute;s seront ignor&eacute;s.</p>";
echo "<p>[*] : ce fichier aura simplement une s&eacute;quence remplac&eacute;e, si vous les cochez, il sera ignor&eacute; mais la s&eacute;quence &agrave; modifi&eacute; sera affich&eacute;e.</p>";
bouton_suivant($etape +1);

} // etape 3

// Etape 4 - Installation des fichiers

if ($etape == 4) {

if ($spip_version_affichee != "1-6")
	{ // Passage en mode simul&eacute; automatique
	  $mode_simule = true; }

echo "<p><b>Installation des fichiers en cours";
if ($mode_simule) {
	echo " [Mode Simul&eacute;]";
}
echo "</b></p>";

function copier_fichier($nom,$chemin_dest,$remplacer,$simule) {
global $extension,$install_dir,$sources_dir;
	$fichier = $nom;
	if (strpos($nom,'.') == false) {
			$fichier .= ".".$extension;
	}
	// mode simul&eacute;, indique seulement ce qu'il faut faire
	if ($simule) {
		echo "$install_dir$sources_dir$fichier &agrave; copier dans $chemin_dest<br>";
		return;
	}
	// realise les copies
	if (($remplacer) AND file_exists($chemin_dest.$fichier)) {
		@unlink($chemin_dest.$fichier);
	}
	elseif (file_exists($chemin_dest.$fichier))	{	
		echo "$fichier ignor&eacute;";
		return false; 
	}
	if (copy($install_dir.$sources_dir.$fichier,$chemin_dest.$fichier)) { 
		echo "$fichier copi&eacute; dans $chemin_dest<br>";
	}
}

function remplacer_dans_fichier($nom,$chemin,$simule) {
	global $fichiers,$recherche_fichier,$extension;
	$fichier = $chemin.$nom.".".$extension;
	$recherche = $recherche_fichier['recherche'][$nom];
	$remplacer = $recherche_fichier['remplacer'][$nom];
	$f = fopen($fichier, 'r');
	$oldContent = fread($f, filesize($fichier));
	if ($simule) {
		echo "Rechercher dans $fichier<br>";
		echo "recherche : $recherche<br>";
		echo "remplac&eacute;  &agrave; par : $remplacer<br>";
		// recherche la chaine pour voir si ca marche
		if (ereg($recherche,$oldContent)) {
			echo "Chaine Trouv&eacute;e";
		}
		return true;
	} else {
		$newContent = ereg_replace($recherche, $remplacer , $oldContent);
		$f = fopen($fichier, 'w');
		fwrite($f, $newContent);
		fclose($f);
		echo "$fichier modifi&eacute;";
	}

}

// Copie, modification des fichiers
echo "Les fichiers sources sont dans $install_dir$sources_dir<br>";
	while (list($id,$nom) = each($fichiers['nom'])) {
	
		$chemin = $root_dir.$fichiers['chemin'][$id];
		// mode de copie du fichier
		
		$copie =  $fichiers['copie'][$id];
		// faut il v&eacute;rifier si l'utilisateur veut ignorer le fichier (fichier d&eacute;ja modifi&eacute;)
		
		$verif_modif = $fichiers['verifier_modif'][$id];
		
		$simule = ($mode_simule);
		
		if (($verif_modif) AND ($modifie[$id])) {
			// fichier &agrave; ignorer -> mode simul&eacute;
			$simule = true;
		} 
		
		echo "<p>[#$id] ";

		if ($copie == 0) {
		copier_fichier($nom,$chemin,true,$simule);
		}
		
		if ($copie == 1) {
		remplacer_dans_fichier($nom,$chemin,$simule);
		}
		
		if ($copie == 2) {
		copier_fichier($nom,$chemin,true,$simule);
		echo "</p>";

		}
	}
bouton_suivant($etape + 1);
} //etape 4

if ($etape == 5) {
	echo "<h2>Initialisation du Plug-in</h2>";
	echo " * Creation de la table des repertoires"; 
	include_ecrire("inc_connect.$extension");
	// elimine une installation pr&eacute;c&eacute;dente..
	$sql = "DROP TABLE spip_directory";
	spip_query($sql);	
	$requete_creation = "CREATE TABLE spip_directory (id_directory smallint(4) NOT NULL auto_increment,path varchar(100) NOT NULL default '', PRIMARY KEY  (id_directory))";
	$q = spip_query($requete_creation);
	echo "<p align='center'>";
	if ($q)	{
		echo "Table Install&eacute;e avec succ&egrave;s<p>";
		echo "<p>Vous allez tre redirig vers l'administration afin de terminer l'installation</p>";
		form_suivant();
		echo "<input type='checkbox' NAME='verouiller_install' value='1'> Verouiller le repertoire d'installation (<i>deny from all</i>). Il ne sera accessible que par FTP. Pour le dverouiller il faudra supprimer le fichier <b>.htaccess</b>";
		bouton_suivant($etape+1);
				}
	 else { echo "Erreur lors de l'installation de la table spip_directory</p>"; }
	
	
	} //etape5

?>
</font>
<font face="Verdana,Arial,Helvetica,sans-serif" size="2" color="#970038"><center><? echo "$plugin_titre v$plugin_version"; ?> - Install Plug-in v0.9 - Clems</center></FONT>
</td></tr></table>
</center>
</body>
</html>
